org 100h

mov ax,13h
int 10h

xor ax,ax
mov dx,3c8h
out dx,al
inc dx
ploop:
mov al,ah
out dx,al
xor al,al
out dx,al
mov al,ah
out dx,al
inc ah
xor al,al
out dx,al
mov al,ah
out dx,al
xor al,al
out dx,al
inc ah
jnz ploop

push word 0a000h	;video memory
pop es

mov bx,0ffffh		;fill screen
bloop:
call rand
mov [es:bx],al
dec bx
jnz bloop

sloop:			;main loop
mov cx,50		;plot 50 random pixels
broop:
call rand
mov bx,ax
call rand
mov [es:bx],al
loop broop

mov cx,1500h		;make 1500h pixels the color of an adjacent pixel
lewp:
call rand		;pick the pixel and get it
mov bx,ax
mov dl,[es:bx]
call rand		;pick which adjacent pixel
xchg ax,bx
and bx,3
shl bx,1
add ax,[adjtable+bx]
xchg ax,bx
mov [es:bx],dl		;plot it in the new spot
loop lewp

vr:			;wait for vertical retrace
mov dx,03dah
in al,dx
test al,8
jz vr

in al,60h		;check for keydown
cmp al,129
jnz sloop

mov ax,3		;print end message then quit
int 10h
mov ah,9
mov dx,text
int 21h
int 20h

rand:			;random number routine from mental surgery
push bx
push cx
push dx
mov ax,[seed1]
mov bx,[seed2]
mov cx,[seed3]
mov dx,[seed4]
add ax,bx
rol ax,cl
xor ax,dx
xchg cl,ch
add bx,cx
add dx,bx
add cx,ax
ror bx,1
sbb ax,dx
mov [seed4],dx
mov [seed3],dx
mov [seed2],dx
mov [seed1],ax
pop dx
pop cx
pop bx
ret

seed1 dw 1234
seed2 dw 5678
seed3 dw 1234h
seed4 dw 5678h

adjtable dw -1,1,-320,320

text: db "Rorschach by pfister (pfister_@mindspring.com)$"
